//Sushovan De
//June 23, 2004
//08:36:53 PM


import java.awt.Color;

/**
*A class that abstracts a ball in 2d
*/
public class Ball implements Runnable{

	/**
	*The radius of the ball
	*/
	public double radius;
	/**
	*The colour of the ball.
	*/
	Color ballColor;
	/**current co-ods
	*/
	float x,y;
	
	Thread t;
	
	public float xIncrement=2.25F;
	public float yIncrement=1.75F;
	int height=Constants.height;
	int width=Constants.width;
	final int speed=  5;
	
	boolean front=false;
	boolean top=false;
	boolean pleasehit=true;
	
	public Ball(int initx, int inity, int hundred_times_speedx, int speed_y, int radius){
		ballColor=null;
		x=initx;
		y=inity;
		this.radius=radius;
		xIncrement=hundred_times_speedx/100.0F;
		yIncrement=speed_y/100.0F;
		t=new Thread(this);
		t.start();
	}
	
	public int getX(){
		return (int)x;
	}
	public int getY(){
		return (int)y;
	}
	public double getRadius(){
		return radius;
	}
	public void run(){
		while(true){
			
			x+=xIncrement;
						
			y+=yIncrement;
						
// 			if(x>=width||x<0){xIncrement=-xIncrement;pleasehit=true;}
			if((x>=width-radius)||x<(0+radius)){xIncrement=-xIncrement;pleasehit=true;}
						
// 			if(y>=height||y<0){yIncrement=-yIncrement;pleasehit=true;}
			if((y>=height-radius)||y<(0+radius)){yIncrement=-yIncrement;pleasehit=true;}
			
			try{Thread.sleep(speed);}catch(InterruptedException exc){}
		}
	}

	public void hit(){
		front=!front;
		top=!top;
		pleasehit=false;
	}
	public void hit(float ux2, float uy2, float sin_theta, float cos_theta){
		//-------------------
		float ux1=xIncrement;
		float uy1=yIncrement;
		//I have all the initial velocities ready.
		
		//Find the velocities along the u and v directions.
		float uu2=ux2*cos_theta+uy2*sin_theta;
		float uv1=uy1*cos_theta-ux1*sin_theta;
		
		//Compute the resultant in the x and y directions.
		float vx1=uu2*cos_theta-uv1*sin_theta;
		float vy1=uu2*sin_theta+uv1*cos_theta;
		
		xIncrement=vx1;
		yIncrement=vy1;
		
		pleasehit=false;
	}
	
	public boolean isHittable(){
		return pleasehit;
	}
	
// 	public void hitStatic(int wherefrom){
// 		switch(wherefrom){
// 		case 1:
// 		case 2:
// 				xIncrement=-xIncrement;
// 				break;
// 		case 3:
// 		case 4:
// 				yIncrement=-yIncrement;
// 				break;
// 		}
// 		pleasehit=true;
// 	}		
	public void hitStatic(int wherefrom){
		switch(wherefrom){
		case 1:
				xIncrement=-Math.abs(xIncrement);
				break;
		case 2:
				xIncrement=Math.abs(xIncrement);
				break;
		case 3:
				yIncrement=-Math.abs(yIncrement);
				break;

		case 4:
				yIncrement=Math.abs(yIncrement);
				break;
		}
		pleasehit=true;
	}		
	

	
}