//Sushovan De
//June 23, 2004
//08:36:35 PM

import java.awt.Graphics;
import java.awt.Color;
import javax.swing.JPanel;

/**
*A class that provides an envioronment for the balls.
*/
public class Envioronment extends JPanel{


	public int height=Constants.height;
	public int width=Constants.width;
	
	Ball red;
	Ball blue;
	staticBox sbox;
	
	int redRadius=Constants.redRadius;
	int blueRadius=Constants.blueRadius;
	
	static Color cb,cr,cg,cs;

	
	public Envioronment(){
		red=new Ball(Constants.redx,Constants.redy,Constants.redvx,Constants.redvy,redRadius);
		blue=new Ball(Constants.bluex,Constants.bluey,Constants.bluevx,Constants.bluevy,blueRadius);
		sbox=new staticBox(Constants.sboxX,Constants.sboxY,Constants.sboxWidth,Constants.sboxHeight);
		cb=new Color(20,20,230);//Blue ball
		cr=new Color(230,20,20);//Red ball
		cg=new Color(255,255,255);//White background(with fleece as white as snow)
		cs=new Color(20,230,20);//The static green obstacle.
	
	}
	protected void paintComponent(Graphics g){
		setBackground(cg);
		super.paintComponent(g);
	    did_that_ball_hit_its_head();
	    hit_the_boxer_and_you_are_out(red);
	    hit_the_boxer_and_you_are_out(blue);
		//The static Obstacle.
		g.setColor(cs);
		g.fillRect(sbox.getX(),sbox.getY(),sbox.getDx(),sbox.getDy());
		g.setColor(cr);
		g.fillOval(red.getX()-redRadius,red.getY()-redRadius,2*redRadius,2*redRadius);
		g.setColor(cb);
		g.fillOval(blue.getX()-blueRadius,blue.getY()-blueRadius,2*blueRadius,2*blueRadius);
		g.drawRect(0,0,width,height);

	}
	
    public void did_that_ball_hit_its_head(){
	    if(red.isHittable()||blue.isHittable())
	    if(Math.abs(red.getX()-blue.getX())<(redRadius+blueRadius))
	    if(Math.abs(red.getY()-blue.getY())<(redRadius+blueRadius)){
		    //red.hit();
		    //blue.hit();
		    
		    float ux,uy;
		    ux=blue.xIncrement;
		    uy=blue.yIncrement;
		    float deltax=red.x-blue.x;
		    float deltay=red.y-blue.y;
		    double angle=Math.atan2(deltay,deltax);
		    float sin_theta=-(float)Math.sin(angle);
		    float cos_theta=-(float)Math.cos(angle);
		    blue.hit(red.xIncrement,red.yIncrement,sin_theta,cos_theta);
		    red.hit(ux,uy,sin_theta,cos_theta);
		    
		    
		    
		    
	    }
	    
    }

	public void hit_the_boxer_and_you_are_out(Ball b){
		//check for top and bottom edges...
		if( (b.x>sbox.x) && (b.x < (sbox.x+sbox.width)) ){//if the center of the ball is within the vertical extents...
			if( b.yIncrement > 0){//if moving downwards...
				if( b.y+b.radius > sbox.y && b.y < sbox.y+sbox.height ){
					b.hitStatic(3);
					return;
				}
				else return;
			}
			else if( b.yIncrement < 0){//if moving upwards...
				if( b.y-b.radius < sbox.y+sbox.height && b.y > sbox.y){
					b.hitStatic(4);
					return;
				}
				else return;
			}
		}
		
		//check for right and left edges...
		if( (b.y > sbox.y) && (b.y < sbox.y+sbox.height) ){// if the center of the ball is within the horizontal extents...
			if( b.xIncrement > 0){//if moving right...
				if(b.x+b.radius > sbox.x && b.x < sbox.x+sbox.width){
					b.hitStatic(1);
					return;
				}
				else return;
			}
			else if ( b.xIncrement < 0){
				if(b.x-b.radius < sbox.x+sbox.width && b.x > sbox.x ){
					b.hitStatic(2);
					return;
				}
				else return;
			}
		}
	}
	

}